unit Setup1Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

const
  ButtonRepeatDelay1 = 1000;
  ButtonRepeatInterval1 = 250;
  ButtonRepeatStep1 = 2000;
  ButtonRepeatDelay2 = 2000;
  ButtonRepeatInterval2 = 100;
  
type
  TSetup1Form = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    CheckBox1: TCheckBox;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CommonSet();
    procedure FormActivate(Sender: TObject);
    procedure EnableDisable();
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    prevRightEndTime: int64;
    prevRightEndIsCurrent: Boolean;
    prevMinutePerPixel: Integer;
    rightEndSYSTEMTIME: TSYSTEMTIME;
    rightEndFILETIME: TFILETIME;
  end;

var
  Setup1Form: TSetup1Form;

implementation

uses kmBattGraphUnit, km_Common;

{$R *.dfm}

var
  RepeatCounter: Integer;
  up: Boolean;
  inIncDecProgress: Boolean;

//
// 
//
procedure IncFileTime(var FT1: TFILETIME; var ST1: TSYSTEMTIME; incp: int64);
var
  u64: TUnion64;
  ST2: TSYSTEMTIME;
  FT2: TFILETIME;
begin
  u64.h32 := FT1.dwHighDateTime;
  u64.l32 := FT1.dwLowDateTime;
  u64.w64 := u64.w64 + incp;
  FT2.dwHighDateTime := u64.h32;
  FT2.dwLowDateTime := U64.l32;
  if FileTimeToSystemTime(FT2, ST2) then begin
    // 
    FT1 := FT2;
    ST1 := ST2
  end else begin
    // s - Ȃ
  end
end;

//
// ߋ
//
procedure DecFileTime(var FT1: TFILETIME; var ST1: TSYSTEMTIME; decp: int64);
var
  u64: TUnion64;
  ST2: TSYSTEMTIME;
  FT2: TFILETIME;
begin
  u64.h32 := FT1.dwHighDateTime;
  u64.l32 := FT1.dwLowDateTime;
  u64.w64 := u64.w64 - decp;
  FT2.dwHighDateTime := u64.h32;
  FT2.dwLowDateTime := U64.l32;
  if FileTimeToSystemTime(FT2, ST2) then begin
    // 
    FT1 := FT2;
    ST1 := ST2
  end else begin
    // s - Ȃ
  end
end;

//
// LZ
//
procedure TSetup1Form.Button1Click(Sender: TObject);
begin
  // w̏ꍇ
  // LZꂽ猳ɖ߂
  if RadioButton2.Checked then begin
    kmBattGraphForm.rightEndTime := prevRightEndTime
  end;
  kmBattGraphForm.rightEndIsCurrent := prevRightEndIsCurrent;
  kmBattGraphForm.minutePerPixel := prevMinutePerPixel;
  Close
end;

//
// ʐݒ胋[`
//
procedure TSetup1Form.CommonSet();
begin
  // 1sNZ̎
  case ComboBox1.ItemIndex of
    0:   kmBattGraphForm.minutePerPixel := 1;     // 1
    1:   kmBattGraphForm.minutePerPixel := 2;     // 2
    2:   kmBattGraphForm.minutePerPixel := 5;     // 5
    3:   kmBattGraphForm.minutePerPixel := 10;    // 10
    4:   kmBattGraphForm.minutePerPixel := 20;    // 20
    5:   kmBattGraphForm.minutePerPixel := 30;    // 30
    6:   kmBattGraphForm.minutePerPixel := 60;    // 1
    7:   kmBattGraphForm.minutePerPixel := 120;   // 2
    8:   kmBattGraphForm.minutePerPixel := 300;   // 5
    9:   kmBattGraphForm.minutePerPixel := 600;   // 10
    10:  kmBattGraphForm.minutePerPixel := 1440;  // 1
    11:  kmBattGraphForm.minutePerPixel := 2880;  // 2
    12:  kmBattGraphForm.minutePerPixel := 7200;  // 5
    13:  kmBattGraphForm.minutePerPixel := 10080; // 1T
    14:  kmBattGraphForm.minutePerPixel := 20160; // 2T
    15:  kmBattGraphForm.minutePerPixel := 43200; // 30
    else kmBattGraphForm.minutePerPixel := 1      // 蓾Ȃ͂
  end;
  // ÂOۑ
  case ComboBox2.ItemIndex of
    0:   kmBattGraphForm.deleteTimer :=  10080; // 1T
    1:   kmBattGraphForm.deleteTimer :=  20160; // 2T
    2:   kmBattGraphForm.deleteTimer :=  30240; // 3T
    3:   kmBattGraphForm.deleteTimer :=  43200; // 30
    4:   kmBattGraphForm.deleteTimer :=  86400; // 60
    5:   kmBattGraphForm.deleteTimer := 129600; // 90
    6:   kmBattGraphForm.deleteTimer := 259200; // 180
    7:   kmBattGraphForm.deleteTimer := 525600; // 1N(365)
    else kmBattGraphForm.deleteTimer := 525600  // 蓾Ȃ͂
  end;
  if RadioButton1.Checked then begin
    kmBattGraphForm.rightEndIsCurrent := True
  end;
  if RadioButton2.Checked then begin
    kmBattGraphForm.rightEndIsCurrent := False
  end;
  kmBattGraphForm.makeEndlessLog := CheckBox1.Checked
end;

//
// OCEAEgʐݒ
//
procedure TSetup1Form.EnableDisable();
begin
  if RadioButton2.Checked then begin
    SpinEdit1.Enabled := True;
    SpinEdit2.Enabled := True;
    SpinEdit3.Enabled := True;
    SpinEdit4.Enabled := True;
    SpinEdit5.Enabled := True;
    Button3.Enabled := True;
    Button4.Enabled := True;
    Button5.Enabled := True
  end else begin
    SpinEdit1.Enabled := False;
    SpinEdit2.Enabled := False;
    SpinEdit3.Enabled := False;
    SpinEdit4.Enabled := False;
    SpinEdit5.Enabled := False;
    Button3.Enabled := False;
    Button4.Enabled := False;
    Button5.Enabled := False
  end
end;

//
// ݒ
//
procedure TSetup1Form.Button2Click(Sender: TObject);
var
  FILETIME: TFILETIME;
  SYSTEMTIME: TSYSTEMTIME;
  u64: TUnion64;
begin
  if RadioButton2.Checked then begin
    // ݒ莞̏ꍇ
    // p^͈̔͂̃`FbN
    SYSTEMTIME.wYear := SpinEdit1.Value;
    SYSTEMTIME.wMonth := SpinEdit2.Value;
    SYSTEMTIME.wDay := SpinEdit3.Value;
    SYSTEMTIME.wHour := SpinEdit4.Value;
    SYSTEMTIME.wMinute := SpinEdit5.Value;
    SYSTEMTIME.wSecond := 0;
    SYSTEMTIME.wMilliseconds := 0;
    if SystemTimeToFileTime(SYSTEMTIME, FILETIME) then begin
      // 
      u64.h32 := FILETIME.dwHighDateTime;
      u64.l32 := FILETIME.dwLowDateTime;
      kmBattGraphForm.rightEndTime := u64.w64 div K;
      CommonSet();
      Close
    end else begin
      // s
      ShowMessage(GetLastErrorStr(GetLastError()))
    end
  end else begin
    CommonSet();
    kmBattGraphForm.ChangeFinishClose
      (kmBattGraphForm.MenuSetupStayInTaskTray.Checked);
    Close
  end
end;

//
// tH[\Ƃ
//
procedure TSetup1Form.FormActivate(Sender: TObject);
begin
  EnableDisable()
end;

//
// ݓ
//
procedure TSetup1Form.RadioButton1Click(Sender: TObject);
begin
  kmBattGraphForm.rightEndIsCurrent := True;
  EnableDisable();
  kmBattGraphForm.DrawAll
end;

//
// w
//
procedure TSetup1Form.RadioButton2Click(Sender: TObject);
begin
  kmBattGraphForm.rightEndIsCurrent := False;
  EnableDisable();
  kmBattGraphForm.DrawAll
end;

//
// {^ꂽ
//
procedure TSetup1Form.Button4MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  u64: TUnion64;
begin
  if Button = mbLeft then begin
    Timer1.Interval := ButtonRepeatDelay1;
    Timer1.Enabled := True;
    up := True;
    IncFileTime(rightEndFileTime, rightEndSystemTime,
                kmBattGraphForm.minutePerPixel * K);
    inIncDecProgress := True;
    SpinEdit1.Value := rightEndSYSTEMTIME.wYear;
    SpinEdit2.Value := rightEndSYSTEMTIME.wMonth;
    SpinEdit3.Value := rightEndSYSTEMTIME.wDay;
    SpinEdit4.Value := rightEndSYSTEMTIME.wHour;
    SpinEdit5.Value := rightEndSYSTEMTIME.wMinute;
    inIncDecProgress := False;
    u64.l32 := rightEndFILETIME.dwLowDateTime;
    u64.h32 := rightEndFILETIME.dwHighDateTime;
    kmBattGraphForm.rightEndTime := u64.w64 div K;
    kmBattGraphForm.DrawAll;
    RepeatCounter := 0
  end
end;

//
// {^ꂽ
//
procedure TSetup1Form.Button4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False
end;

//
// ߋ{^ꂽ
//
procedure TSetup1Form.Button3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  u64: TUnion64;
begin
  if Button = mbLeft then begin
    Timer1.Interval := ButtonRepeatDelay1;
    Timer1.Enabled := True;
    up := False;
    DecFileTime(rightEndFileTime, rightEndSystemTime,
                kmBattGraphForm.minutePerPixel * K);
    inIncDecProgress := True;
    SpinEdit1.Value := rightEndSYSTEMTIME.wYear;
    SpinEdit2.Value := rightEndSYSTEMTIME.wMonth;
    SpinEdit3.Value := rightEndSYSTEMTIME.wDay;
    SpinEdit4.Value := rightEndSYSTEMTIME.wHour;
    SpinEdit5.Value := rightEndSYSTEMTIME.wMinute;
    inIncDecProgress := False;
    u64.l32 := rightEndFILETIME.dwLowDateTime;
    u64.h32 := rightEndFILETIME.dwHighDateTime;
    kmBattGraphForm.rightEndTime := u64.w64 div K;
    kmBattGraphForm.DrawAll;
    RepeatCounter := 0
  end
end;

//
// ߋ{^ꂽ
//
procedure TSetup1Form.Button3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False
end;

//
// ݂NbN
//
procedure TSetup1Form.Button5Click(Sender: TObject);
var
  u64: TUnion64;
begin
  rightEndSYSTEMTIME := kmBattGraphForm.CurrentSYSTEMTIME;
  rightEndFILETIME := kmBattGraphForm.CurrentFILETIME;
  inIncDecProgress := True;
  SpinEdit1.Value := rightEndSYSTEMTIME.wYear;
  SpinEdit2.Value := rightEndSYSTEMTIME.wMonth;
  SpinEdit3.Value := rightEndSYSTEMTIME.wDay;
  SpinEdit4.Value := rightEndSYSTEMTIME.wHour;
  SpinEdit5.Value := rightEndSYSTEMTIME.wMinute;
  inIncDecProgress := False;
  u64.l32 := rightEndFILETIME.dwLowDateTime;
  u64.h32 := rightEndFILETIME.dwHighDateTime;
  kmBattGraphForm.rightEndTime := u64.w64 div K;
  kmBattGraphForm.DrawAll
end;

//
// ZtEs[g
//
procedure TSetup1Form.Timer1Timer(Sender: TObject);
var
  u64: TUnion64;
begin
  if RepeatCounter * ButtonRepeatInterval1 > ButtonRepeatStep1 then begin
    Timer1.Interval := ButtonRepeatInterval2
  end else begin
    Timer1.Interval := ButtonRepeatInterval1
  end;
  RepeatCounter := RepeatCounter + 1;
  if up then begin
    IncFileTime(rightEndFileTime, rightEndSystemTime,
                kmBattGraphForm.minutePerPixel * K)
  end else begin
    DecFileTime(rightEndFileTime, rightEndSystemTime,
                kmBattGraphForm.minutePerPixel * K)
  end;
  inIncDecProgress := True;
  SpinEdit1.Value := rightEndSYSTEMTIME.wYear;
  SpinEdit2.Value := rightEndSYSTEMTIME.wMonth;
  SpinEdit3.Value := rightEndSYSTEMTIME.wDay;
  SpinEdit4.Value := rightEndSYSTEMTIME.wHour;
  SpinEdit5.Value := rightEndSYSTEMTIME.wMinute;
  inIncDecProgress := False;
  u64.l32 := rightEndFILETIME.dwLowDateTime;
  u64.h32 := rightEndFILETIME.dwHighDateTime;
  kmBattGraphForm.rightEndTime := u64.w64 div K;
  kmBattGraphForm.DrawAll
end;

//
// 1sNZ̕ύX
//
procedure TSetup1Form.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0:   kmBattGraphForm.minutePerPixel := 1;     // 1
    1:   kmBattGraphForm.minutePerPixel := 2;     // 2
    2:   kmBattGraphForm.minutePerPixel := 5;     // 5
    3:   kmBattGraphForm.minutePerPixel := 10;    // 10
    4:   kmBattGraphForm.minutePerPixel := 20;    // 20
    5:   kmBattGraphForm.minutePerPixel := 30;    // 30
    6:   kmBattGraphForm.minutePerPixel := 60;    // 1
    7:   kmBattGraphForm.minutePerPixel := 120;   // 2
    8:   kmBattGraphForm.minutePerPixel := 300;   // 5
    9:   kmBattGraphForm.minutePerPixel := 600;   // 10
    10:  kmBattGraphForm.minutePerPixel := 1440;  // 1
    11:  kmBattGraphForm.minutePerPixel := 2880;  // 2
    12:  kmBattGraphForm.minutePerPixel := 7200;  // 5
    13:  kmBattGraphForm.minutePerPixel := 10080; // 1T
    14:  kmBattGraphForm.minutePerPixel := 20160; // 2T
    15:  kmBattGraphForm.minutePerPixel := 43200; // 30
    else kmBattGraphForm.minutePerPixel := 1      // 蓾Ȃ͂
  end;
  kmBattGraphForm.DrawAll
end;

//
// wύX
// tÓ`FbN
//
procedure TSetup1Form.SpinEdit1Change(Sender: TObject);
var
  u64: TUnion64;
begin
  // SpinEditɒlSpinEditnChangeĂяoď2d
  // sĂ܂̂h~
  if not inIncDecProgress then begin
    rightEndSYSTEMTIME.wYear := SpinEdit1.Value;
    rightEndSYSTEMTIME.wMonth := SpinEdit2.Value;
    rightEndSYSTEMTIME.wDay := SpinEdit3.Value;
    rightEndSYSTEMTIME.wHour := SpinEdit4.Value;
    rightEndSYSTEMTIME.wMinute := SpinEdit5.Value;
    rightEndSYSTEMTIME.wSecond := 0;
    rightEndSYSTEMTIME.wMilliseconds := 0;
    if SystemTimeToFileTime(rightEndSYSTEMTIME, rightEndFILETIME) then begin
      // 
      u64.h32 := rightEndFILETIME.dwHighDateTime;
      u64.l32 := rightEndFILETIME.dwLowDateTime;
      kmBattGraphForm.rightEndTime := u64.w64 div K;
      kmBattGraphForm.DrawAll
    end else begin
      // sȂ牽Ȃ
    end
  end
end;

end.
